#!/usr/bin/env python
# coding: utf-8

# In[45]:


import os
from pathlib import Path

frequency = {}
from nltk.stem import PorterStemmer
from nltk.tokenize import sent_tokenize, word_tokenize

ps = PorterStemmer()
with open(str(Path(__file__).resolve().parent)+"/paragraph.txt", 'r') as f:
    for line in f:
        for word in line.split():
            word = ps.stem(word.lower().strip('.,'))

            if word in frequency: frequency[word] += 1
            else: frequency[word] = 1


# In[46]:


import math
frequency_sorted = sorted(frequency.items(), key=lambda x: x[1], reverse=True)

log_frequency = []
log_rank = []
for i in range(len(frequency_sorted)):
    print(frequency_sorted[i][0], frequency_sorted[i][1] )
    log_frequency.append(math.log(frequency_sorted[i][1]))
    log_rank.append(math.log(i+1))
    


# In[47]:


import matplotlib.pyplot as plt

plt.ylabel("log(frequency)")
plt.xlabel("log(rank)")
plt.plot(log_rank, log_frequency)


# In[43]:


print("Total terms: ",len(frequency_sorted))

